## cd-boot-images 1

=== debian/changelog ===
cd-boot-images (1) groovy; urgency=medium

  * Initial Release.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Fri, 22 May 2020 14:07:10 +0100
