=== debian/control ===
Source: cd-boot-images
Section: main/misc
Priority: optional
Maintainer: Dimitri John Ledkov <xnox@ubuntu.com>
Build-Depends: debhelper-compat (= 12),
               dosfstools,
               grub-common,
               grub-efi-amd64-signed [amd64],
               grub-efi-arm64-signed [arm64],
               grub-ieee1275-bin [ppc64el],
               grub-pc-bin [amd64],
               mtools,
               python3-apt,
               shim-signed [amd64]
Standards-Version: 4.4.1

Package: cd-boot-images
Architecture: amd64 arm64 ppc64el
Built-Using: ${Built-Using}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: assembled boot images for debian-cd and ubuntu-image
 architecture specific boot images (both signed and unsigned) are
 assembled here to be used by debian-cd and ubuntu-image.
 .
 Trees of booloader components are profided together with a sample
 xorriso command to use.
 .
 In addition to the provided files, grub.cfg has to be provided by
 consumer of these products.
 .
 This package must be rebuild whenever Built-Using declared packages
 are updated - namely grub2-signed and shim-signed.
